<?php
namespace Drupal\skillset_inview\Plugin\Field\FieldWidget;

use Drupal\Core\Field\FieldItemListInterface;
use Drupal\Core\Field\WidgetBase;
use Drupal\Core\Form\FormStateInterface;

/**
 * Plugin implementation of the 'skillset_item_widget' widget.
 *
 * @FieldWidget(
 *   id = "skillset_item_widget",
 *   label = @Translation("Skillset Item Widget"),
 *   field_types = {
 *     "skillset_item"
 *   }
 * )
 */
class SkillsetItemWidget extends WidgetBase {

  /**
   * {@inheritdoc}
   */
  public function formElement(FieldItemListInterface $items, $delta, array $element, array &$form, FormStateInterface $form_state) {
    $element['title'] = [
      '#type' => 'textfield',
      '#title' => $this->t('Title'),
      '#default_value' => isset($items[$delta]->title) ? $items[$delta]->title : NULL,
    ];

    $rangeDefault = isset($items[$delta]->percentage) ? $items[$delta]->percentage : NULL;
    $element['percentage'] = [
      '#type' => 'range',
      '#title' => $this->t('Percentage'),
      '#default_value' => $rangeDefault,
      '#min' => 1,
      '#max' => 100,
      '#field_suffix' => '<span class="visual-assist nojs"><span class="current">'.$rangeDefault.'</span>%</span>',

    ];

    return $element;
  }
}
